<%-- $Id: zoom.jsp 7420 2017-11-03 11:28:10Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	Open a larger window for editing text in a textarea.

	@param title The title of the input field that is zoomed
	@param form The name of the form where the zoomed input field is located
	@param textarea The name of the textarea that is zoomed

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>
<%
	String title = request.getParameter("title");
	String textarea = request.getParameter("textarea");
	boolean disabled = Values.getBoolean(request.getParameter("disabled"));
	boolean useToolbar = Values.getBoolean(request.getParameter("useToolbar"));
%>
<base:page type="popup" title="<%=title%>">
<base:head scripts="menu.js,~zoom.js" styles="toolbar.css,menu.css,help.css" />
<base:body>
	<h1><%=title%> <base:help helpid="zoom.edit" /></h1>
	
	<div id="page-data" class="datacontainer"
		data-textarea="<%=textarea%>"
	></div>
	
	<form name="zoom">

<div class="content bg-filled-50">
	<%
	if (useToolbar)
	{
		%>
		<div class="absolutefull" style="height: 2em;">
		<m:menu
			id="listtype"
			style="display: none;">			
		<m:menuitem 
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;ol&gt;"
			data-suffix="&lt;/ol&gt;"
			title="Ordered list" 
			tooltip="Insert an ordered list"
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;ul&gt;"
			data-suffix="&lt;/ul&gt;"
			title="Unordered list"
			tooltip="Insert an unordered list"
		/>			
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;li&gt;"
			data-suffix="&lt;/li&gt;"
			title="List item"
			tooltip="Insert a listitem."
		/>			
		</m:menu>
		<m:menu
			id="tableitem"
			style="display: none;">
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;table&gt;"
			data-suffix="&lt;/table&gt;"
			title="Table"
			tooltip="Insert a table"
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;tr&gt;"
			data-suffix="&lt;/tr&gt;"
			title="Row"
			tooltip="Insert a tablerow."
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;td&gt;"
			data-suffix="&lt;/td&gt;"
			title="Cell"
			tooltip="Insert a datacell."
		/>
		</m:menu>
		<m:menu
			id="textformats"
			style="display: none;">
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;imp&gt;"
			data-suffix="&lt/imp&gt;"
			title="Important"
			tooltip="Mark text as important"
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;ui&gt;"
			data-suffix="&lt/ui&gt;"
			title="User input"
			tooltip="Mark text as user input."
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;req&gt;"
			data-suffix="&lt/req&gt;"
			title="Required"
			tooltip="Mark text as required user input."
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;btn&gt;"
			data-suffix="&lt/btn&gt;"
			title="Button text"
			tooltip="Mark text to symbol a button."
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;mnu&gt;"
			data-suffix="&lt/mnu&gt;"
			title="Menu text"
			tooltip="Mark text to symbol a menu."
		/>
		</m:menu>		
		<m:menu
			id="link"
			style="display: none;"
		>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="{@include "
			data-suffix="}"
			title="Insert helptext"
			tooltip="Insert another helptext in this text."
		/>		
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="{@link "
			data-suffix="}"
			title="Internal link"
			tooltip="Insert a link to another help topic."
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;a&nbsp;href=&#34;&#34;&gt;"
			data-suffix="&lt;/a&gt;"
			title="External link"
			tooltip="Insert a link to an external web page."
		/>
		<m:menuitem
			subclass="auto-init"
			data-auto-init="enclose-selection"
			data-prefix="&lt;a&nbsp;name=&#34;&#34;&gt;"
			data-suffix="&lt;/a&gt;"
			title="Bookmark"
			tooltip="Insert a bookmark"
		/>
		</m:menu>
				<tbl:toolbar subclass="bottomborder">												
					<tbl:button 
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix="&lt;b&gt;"
						data-suffix="&lt;/b&gt;"
						tooltip="Bold"
						image="text_bold.png"
					/>
					<tbl:button
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix="&lt;i&gt;"
						data-suffix="&lt;/i&gt;"
						tooltip="Italic"							
						image="text_italic.png"
					/>
					<tbl:button
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix="&lt;u&gt;"
						data-suffix="&lt;/u&gt;"
						tooltip="Underline"
						image="text_underline.png"
					/>											
					<tbl:button
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix="&lt;h3&gt;"
						data-suffix="&lt;/h3&gt;"
						tooltip="Header 3"
						image="text_h3.png"
					/>
					<tbl:button
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix="&lt;h4&gt;"
						data-suffix="&lt;/h4&gt;"
						tooltip="Header 4"
						image="text_h4.png"
					/>
					<tbl:button
						subclass="auto-init"
						data-auto-init="menu-anchor"
						data-menu-id="textformats"
						tooltip="Textstyle"
						image="text_style_edit.gif"
					/>						
					<tbl:button
						subclass="auto-init"
						data-auto-init="menu-anchor"
						data-menu-id="tableitem"
						tooltip="Table"
						image="text_table.png"
					/>
					<tbl:button
						subclass="auto-init"
						data-auto-init="menu-anchor"
						data-menu-id="listtype"
						tooltip="List"
						image="text_list.gif"
					/>
					<tbl:button
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix="&lt;br&gt;"
						data-suffix=""
						tooltip="New line"
						image="text_newline.gif" 
					/>
					<tbl:button
						subclass="auto-init"
						data-auto-init="enclose-selection"
						data-prefix="&lt;p&gt;"
						data-suffix="&lt;/p&gt;"
						tooltip="New paragraph"
						image="text_paragraph.gif"
					/>	
					<tbl:button
						subclass="auto-init"
						data-auto-init="menu-anchor"
						data-menu-id="link"
						tooltip="New link"
						image="text_link.png"
					/>							
				</tbl:toolbar>
				</div>
				<%
			}
			%>
			<div class="absolutefull" style="<%=useToolbar ? "top: 2em;" : ""%>">
			<table class="fullcc input100 bottomborder"><tr><td style="padding: 5px;">
			<textarea class="autoheight" id="zoom" name="zoom" rows="20"
				<%=disabled ? "disabled" : ""%>></textarea>
			</td></tr></table>
			</div>
		</div>
		</form>
	<base:buttongroup subclass="dialogbuttons">
		<base:button id="btnSave" title="Ok" visible="<%=!disabled%>" />
		<base:button id="close" title="<%=disabled ? "Close" : "Cancel" %>" />
	</base:buttongroup>
</base:body>
</base:page>
