/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2017 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var VerifyEmail = function()
{
	
	var verify = {};
	
	verify.initPage = function()
	{
		Events.doOnEnter('verificationCode', verify.submitVerification);
		Buttons.addClickHandler('btnOk', verify.submitVerification);
		Buttons.addClickHandler('close', App.closeWindow);
	}
	

	/**
		Send the login form.
	*/
	verify.submitVerification = function(event)
	{
		var frm = document.forms['verify'];
		
		if (frm.verificationCode.value == '')
		{
			Forms.showNotification('verificationCode', 'Please enter the verification code!');
			return;
		}
		
		frm.submit();
	}
	
	return verify;
}();

Doc.onLoad(VerifyEmail.initPage);


